/*----------------------------------------------------------------------------
ļ:	TXAPI.C
:	ʾ⺯
----------------------------------------------------------------------------*/
#include		<stdlib.h>
#include		<dos.h>

#define			FALSE		0
#define			TRUE		1

/*----------------------------------------------------------------------------
			 UCDOS ǷѾ
----------------------------------------------------------------------------*/
int CheckUCDOS(void)
{
   union REGS		regs;

   regs.x.ax=0xdb00;
   int86(0x2f,&regs,&regs);
   if (regs.h.al != 0xff || regs.x.bx != 0x5450 || regs.x.dx < 5) return FALSE;
   else return TRUE;
}

/*----------------------------------------------------------------------------
			ʾǷѾ
----------------------------------------------------------------------------*/
int CheckTX(void)
{
   union REGS		regs;

   if (!CheckUCDOS()) return FALSE;

   regs.h.ah=0;
   regs.h.al=0x11;
   int86(0x79,&regs,&regs);
   return(regs.x.flags & 0x40);
}

/*----------------------------------------------------------------------------
			ĳģʽǷΪʾʽ
:	Mode		ģʽ
----------------------------------------------------------------------------*/
int IsChineseMode(int Mode)
{
   struct REGPACK	regpack;

   if (!CheckUCDOS()) return FALSE;

   regpack.r_ax=0xff00;
   regpack.r_bx=(Mode << 8) + 3;
   intr(0x10,&regpack);
   return ((regpack.r_ax & 0xff) == 0);
}

/*----------------------------------------------------------------------------
			ʾʽ
:	Mode		ʾʽ
----------------------------------------------------------------------------*/
void SetVideoMode(int Mode)
{
   printf("\16[m%d]",Mode);
}

/*----------------------------------------------------------------------------
			
:	Color		Ļɫ
----------------------------------------------------------------------------*/
void Cls(int Color)
{
   if (Color > 0) printf("\16[CL%d]",Color << 4);
   else printf("\16[CL]");
}

/*----------------------------------------------------------------------------
			Ժͼɫ
:	Color		ɫ
----------------------------------------------------------------------------*/
void SetColor(int Color)
{
   printf("\16[CO%d]",Color);
}

/*----------------------------------------------------------------------------
			ñ
:	Scale		
			ʵʵĹϵʽΪ:
			ʵʱ =  / 16
----------------------------------------------------------------------------*/
void SetScale(int Scale)
{
   printf("\16[SC%d]",Scale);
}

/*----------------------------------------------------------------------------
			ͼʽ
:	WriteMode	ͼʽ
			0		ʽͼ
			1		ʽͼ
----------------------------------------------------------------------------*/
void SetWriteMode(int WriteMode)
{
   printf("\16[X%d]",WriteMode);
}

/*----------------------------------------------------------------------------
			
:	Style		
			0-12		ڲ
			13		ûԶ
----------------------------------------------------------------------------*/
void SetFillStyle(int Style)
{
   printf("\16[ST%d]",Style);
}

/*----------------------------------------------------------------------------
			ûͼ
:	Pattern		ͼ, 8ֽ
----------------------------------------------------------------------------*/
void SetFillPattern(unsigned char *Pattern)
{
   int			i;

   printf("\16[DS");
   for (i=0;i<8;i++) printf("%d,",Pattern[i]);
   printf("]");
}

/*----------------------------------------------------------------------------
			
:	x,y		
----------------------------------------------------------------------------*/
void PutPixel(int x,int y)
{
   printf("\16[D%d,%d]",x,y);
}

/*----------------------------------------------------------------------------
			
:	x,y		
----------------------------------------------------------------------------*/
int GetPixel(int x,int y)
{
   union REGS		regs;

   regs.h.ah=0x0c;
   regs.x.cx=x;
   regs.x.dx=y;
   int86(0x10,&regs,&regs);
   return (regs.h.al);
}

/*----------------------------------------------------------------------------
			
:	(x1,y1)		ֱϽ
	(x2,y2)		ֱ½
----------------------------------------------------------------------------*/
void Line(int x1,int y1,int x2,int y2)
{
   printf("\16[L%d,%d,%d,%d]",x1,y1,x2,y2);
}

/*----------------------------------------------------------------------------
			
:	(x,y)		ֱյ
			ֱΪϴֱߵյ
----------------------------------------------------------------------------*/
void LineTo(int x,int y)
{
   printf("\16[LT%d,%d]",x,y);
}

/*----------------------------------------------------------------------------
			ο
:	(x1,y1)		οϽ
	(x2,y2)		ο½
----------------------------------------------------------------------------*/
void Rectangle(int x1,int y1,int x2,int y2)
{
   printf("\16[R%d,%d,%d,%d]",x1,y1,x2,y2);
}

/*----------------------------------------------------------------------------
			ͼ
:	(x1,y1)		ͼϽ
	(x2,y2)		ͼ½
----------------------------------------------------------------------------*/
void Bar(int x1,int y1,int x2,int y2)
{
   printf("\16[B%d,%d,%d,%d]",x1,y1,x2,y2);
}

/*----------------------------------------------------------------------------
			Բ
:	(x,y)		Բ
	r		뾶
----------------------------------------------------------------------------*/
void Circle(int x,int y,int r)
{
   printf("\16[C%d,%d,%d]",x,y,r);
}

/*----------------------------------------------------------------------------
			Բ
:	(x,y)		Բ
	xr		ԲX᷽뾶
	yr		ԲY᷽뾶
	StartAngle	ʼǶ, λ
	EndAngle	ֹǶ, λ
----------------------------------------------------------------------------*/
void Ellipse(int x,int y,int StartAngle,int EndAngle,int xr,int yr)
{
   printf("\16[E%d,%d,%d,%d,%d,%d,0]",x,y,StartAngle,EndAngle,xr,yr);
}

/*----------------------------------------------------------------------------
			Բ
:	(x,y)		Բ
	r		뾶
	StartAngle	ʼǶ, λ
	EndAngle	ֹǶ, λ
----------------------------------------------------------------------------*/
void Arc(int x,int y,int StartAngle,int EndAngle,int r)
{
   printf("\16[E%d,%d,%d,%d,%d,%d,0]",x,y,StartAngle,EndAngle,r,r);
}

/*----------------------------------------------------------------------------
			Բͼ
:	(x,y)		Բ
	r		뾶
	StartAngle	ʼǶ, λ
	EndAngle	ֹǶ, λ
	FillColor	ͼɫ
			ڱͼͨ䷽ʽʵֵ, 
----------------------------------------------------------------------------*/
void PieSlice(int x,int y,int StartAngle,int EndAngle,int r,int FillColor)
{
   printf("\16[E%d,%d,%d,%d,%d,%d,2,%d]",x,y,StartAngle,EndAngle,r,r,FillColor);
}

/*----------------------------------------------------------------------------
			
:	(x,y)		Բ
	xr		X᷽뾶
	yr		Y᷽뾶
	StartAngle	ʼǶ, λ
	EndAngle	ֹǶ, λ
----------------------------------------------------------------------------*/
void Sector(int x,int y,int StartAngle,int EndAngle,int xr,int yr)
{
   printf("\16[E%d,%d,%d,%d,%d,%d,1]",x,y,StartAngle,EndAngle,xr,yr);
}

/*----------------------------------------------------------------------------
			
:	(x,y)		ӵ
	FillColor	ɫ
			߽ɫΪǰͼɫ
----------------------------------------------------------------------------*/
void FloodFill(int x,int y,int FillColor)
{
   printf("\16[F%d,%d,%d]",x,y,FillColor);
}

/*----------------------------------------------------------------------------
			
:	Str		ʾ
----------------------------------------------------------------------------*/
void DefineMacro(unsigned char *Str)
{
   printf("\16[MA%s]",Str);
}

/*----------------------------------------------------------------------------
			ִк
----------------------------------------------------------------------------*/
void ExecuteMacro(void)
{
   printf("\16[ME]");
}

/*----------------------------------------------------------------------------
			ʾλ
:	x,y		
----------------------------------------------------------------------------*/
void SetPosition(int x,int y)
{
   printf("\16[{-%d|%d}]",x,y);
}

/*----------------------------------------------------------------------------
			Ԥ
:	Style		Ԥ, Ϊһַ
			ȡֵΧΪ A - X, a - t
----------------------------------------------------------------------------*/
void SetFontStyle(unsigned char Style)
{
   printf("\16[{@%c}]",Style);
}

/*----------------------------------------------------------------------------
			ʾС
:	Width		ֿ, ĿΪֵһ
	Height		ֵĸ߶
----------------------------------------------------------------------------*/
void SetFontSize(int Width,int Height)
{
   printf("\16[{@%d,%d}]",Height,Width);
}

/*----------------------------------------------------------------------------
			ѡʾֵֿ
:	FontNo		ֿ, ֿֿƶձĶʹֲ
----------------------------------------------------------------------------*/
void SetFont(int FontNo)
{
   printf("\16[{=%d}]",FontNo);
}

/*----------------------------------------------------------------------------
			ʾּ
:	CharSpace	ּ, ֵּԶӱ
----------------------------------------------------------------------------*/
void SetCharSpace(int CharSpace)
{
   printf("\16[{^%d}]",CharSpace);
}

/*----------------------------------------------------------------------------
			ʾɫ
:	FrColor		ʾǰɫ
	BgColor		ʾıɫ
----------------------------------------------------------------------------*/
void SetTextColor(int FrColor,int BgColor)
{
   printf("\16[{(%d)%d}]",FrColor,BgColor);
}

/*----------------------------------------------------------------------------
			ʾʽ
:	WriteMode	ʾʽ
			0		ʽʾ
			1		ʽʾ
----------------------------------------------------------------------------*/
void SetTextWriteMode(int WriteMode)
{
   printf("\16[{%%%d}]",WriteMode);
}

/*----------------------------------------------------------------------------
			ʾִ
:	Str		ַ
			ʾַаʾַ(ַ@),
			ʾ϶
----------------------------------------------------------------------------*/
void OutText(unsigned char *Str)
{
   printf("\16[{%s}]",Str);
}

/*----------------------------------------------------------------------------
			ָλʾִ
:	x,y		ʾֵ
	Str		ַ
			ʾַаʾַ(ַ@),
			ʾ϶
----------------------------------------------------------------------------*/
void OutTextxy(int x,int y,unsigned char *Str)
{
   SetPosition(x,y);
   OutText(Str);
}

/*----------------------------------------------------------------------------
			Ļͼ
:	x1,y1		ΪͼϽ
	x2,y2		Ϊͼ½
	Name		Ϊͼļ, ͼΪPCXʽ
----------------------------------------------------------------------------*/
void GetImage(int x1,int y1,int x2,int y2,unsigned char *Name)
{
   printf("\16[SA%d,%d,%d,%d,%s]",x1,y1,x2,y2,Name);
}

/*----------------------------------------------------------------------------
			ĻʾPCXͼ
:	x,y		ʾͼϽ
	Name		Ϊʾͼļ, ͼΪPCXʽ
----------------------------------------------------------------------------*/
void PutImage(int x,int y,unsigned char *Name)
{
   printf("\16[RE%d,%d,%s]",x,y,Name);
}

/*----------------------------------------------------------------------------
			ĻʾPCXͼ
:	x,y		ʾͼϽ
	w		ʾͼĿ, ͼʵʿȴw, ͼ񱻽ض
	h		ʾͼĸ߶, ͼʵʸ߶ȴh, ͼ񱻽ض
	Name		Ϊʾͼļ, ͼΪPCXʽ
----------------------------------------------------------------------------*/
void PutPartImage(int x,int y,int w,int h,unsigned char *Name)
{
   printf("\16[RP%d,%d,%d,%d,%s]",x,y,w,h,Name);
}

/*----------------------------------------------------------------------------
			ڹ̶ʾСͼ
:	x,y		ʾͼϽ
	w		ʾͼĿ, ͼʵʿȲw,ͼԶ
	h		ʾͼĸ߶, ͼʵʸ߶Ȳh,ͼԶ
	Name		Ϊʾͼļ, ͼΪPCXʽ
----------------------------------------------------------------------------*/
void PutImageInWin(int x,int y,int w,int h,unsigned char *Name)
{
   printf("\16[RF%d,%d,%d,%d,%s]",x,y,w,h,Name);
}

/*----------------------------------------------------------------------------
			ͼű
:	xScale		ˮƽ
	yScale		ֱ
			űӼĹϵʽΪ:
			ű =  / 16
----------------------------------------------------------------------------*/
void SetImageScale(int xScale,int yScale)
{
   printf("\16[IS%d,%d]",xScale,yScale);
}

/*----------------------------------------------------------------------------
			ͼʾʽ
:	Mode		ͼʾʽ
			0		Ƿʽ(COPY_PUT)
			1		뷽ʽ(AND)
			2		ʽ(OR)
			3		ʽ(XOR)
----------------------------------------------------------------------------*/
void SetPutImageMode(int Mode)
{
   printf("\16[PM%d]",Mode);
}

/*----------------------------------------------------------------------------
			õɫ屣״̬
:	Mode		0		ɫ
			1		ɫ
			256ɫʾʽЧ

			ڵɫ屣״̬, ʾ256ͼʱǰ16ɫĵɫ,
			ᱻ޸
----------------------------------------------------------------------------*/
void SetProtectPalette(int Mode)
{
   printf("\16[PP%d]",Mode);
}

/*----------------------------------------------------------------------------
			õɫ״̬
:	Mode		0		ʾͼʱ޸ĵɫ
			1		ʾͼʱ޸ĵɫ
----------------------------------------------------------------------------*/
void SetPaletteMode(int Mode)
{
   printf("\16[SP%d]",Mode);
}

/*----------------------------------------------------------------------------
			ƶͼ
:	x1,y1		ԴͼϽ
	x2,y2		Դͼ½
	x3,y3		ƶͼϽ
----------------------------------------------------------------------------*/
void MoveImage(int x1,int y1,int x2,int y2,int x3,int y3)
{
   printf("\16[MI%d,%d,%d,%d,%d,%d]",x1,y1,x2,y2,x3,y3);
}

/*----------------------------------------------------------------------------
			
:	Str		ʽд
			ڼ׵дʽĶʹֲ
----------------------------------------------------------------------------*/
void Sound(unsigned char *Str)
{
   printf("\16[SO%s]",Str);
}

/*----------------------------------------------------------------------------
			ֹ
			Իڵļδ, ʹñǿ
			ֹ
----------------------------------------------------------------------------*/
void EndSound(void)
{
   printf("\16[SE]");
}

/*----------------------------------------------------------------------------
			ù˸ٶ
:	n		˸λΪ1/18, n=0ʾֹ˸
----------------------------------------------------------------------------*/
void SetCursorSpeed(int n)
{
   printf("\16[CU0,%d]",n);
}

/*----------------------------------------------------------------------------
			ʾ
----------------------------------------------------------------------------*/
void EnableCursor(void)
{
   printf("\16[CU1,1]");
}

/*----------------------------------------------------------------------------
			ֹʾ
----------------------------------------------------------------------------*/
void DisableCursor(void)
{
   printf("\16[CU1,0]");
}

/*----------------------------------------------------------------------------
			ͼηʽʾ
----------------------------------------------------------------------------*/
void EnableGraphCursor(void)
{
   printf("\16[CU2,1]");
}

/*----------------------------------------------------------------------------
			ֹͼηʽʾ
----------------------------------------------------------------------------*/
void DisableGraphCursor(void)
{
   printf("\16[CU2,0]");
}

/*----------------------------------------------------------------------------
			ʾ
----------------------------------------------------------------------------*/
void EnablePrompt(void)
{
   printf("\16[KB1,1]");
}

/*----------------------------------------------------------------------------
			رʾ
----------------------------------------------------------------------------*/
void DisablePrompt(void)
{
   printf("\16[KB1,0]");
}

/*----------------------------------------------------------------------------
			ѡ뷨
:	n		뷨
			1			Alt-F1
			2			Alt-F2
			...
			0			Alt-F10
----------------------------------------------------------------------------*/
void SelectPrompt(int n)
{
   printf("\16[KB0,%d]",n);
}
